routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::middleware('cekakun')->group(function () {
    Route::get('/', "Dashboard\DashboardController@index")->name('dashboard');
    Route::get('test_word/{id}', "Dashboard\DashboardController@testWord");
    Route::resource("jabatan","DataMaster\JabatanController");
    Route::resource("tempat_tugas","DataMaster\TipePegawaiController");
    Route::resource("tempat_presensi","Presensi\TempatPresensiController");
    Route::resource("pegawai","Pengguna\PegawaiController");
    Route::resource("akun","Pengguna\AkunController");
    Route::get("all_pegawai","Pengguna\PegawaiController@all_pegawai");
    Route::resource('rule_presensi','Presensi\RulePresensiController');
    Route::resource('waktu_presensi','Presensi\WaktuPresensiController');
    Route::resource('rule_hari_libur','Presensi\RuleHariLiburController');
    Route::get("logout","Auth\LoginController@logout")->name('logout');
    Route::resource('belum_presensi', 'Presensi\BelumPresensiController');
    Route::resource('log_presensi', 'Presensi\PresensiController');
    Route::get('log_presensi/group/{tipe}','Presensi\PresensiController@showPerTempatTugas');
    Route::post('print_data', 'Presensi\PresensiController@rekapData');
    Route::get('detail_presensi/{pegawai}','Presensi\PresensiController@detailPresensi');
    // Cetak Data
    Route::get('printData','Presensi\PresensiController@printData');
    Route::post('print_data_kolektif', 'Presensi\PresensiController@rekapDataKolektif');
    Route::get('cetak_pdf_kolektif/{pegawai}','Presensi\PresensiController@printDataCollective');
    Route::post('cetak_pdf_all_kolektif','Presensi\PresensiController@cetakAllPegawai');
    Route::get('print_pdf_all_kolektif/{tipe}','Presensi\PresensiController@printDataAll');
    Route::get('presensi_excel/{id}','Presensi\PresensiController@exportExcel');
    //Route::get('log_presensi_pegawai/{id}','Presensi\PresensiController@show');
    Route::post('ketidakhadiran/add', 'Presensi\KetidakhadiranController@addIzin');
    Route::resource('ketidakhadiran', 'Presensi\KetidakhadiranController');
    Route::get('pengajuan_izin_cuti/{idpegawai}/{presensiid}','Presensi\KetidakhadiranController@cetakPengajuanCutiIzin');
    Route::resource('periode','Presensi\PeriodeController');
    Route::post('surat/act','Penugasan\TugasController@update');

    // Penugasan
    Route::get('penugasan/rekap', 'Penugasan\TugasController@rekap');
    Route::get('penugasan/cetak_pdf', 'Penugasan\TugasController@cetakPdf');
    Route::get('penugasan/export_excel', 'Penugasan\TugasController@export_excel');
    Route::resource('penugasan','Penugasan\TugasController');
    Route::get('penugasan/detail/{id}', 'Penugasan\TugasController@detail');
    Route::put('penugasan/detail/batal', 'Penugasan\TugasController@batal');
    Route::put('penugasan/detail/kirim', 'Penugasan\TugasController@kirim');
    Route::put('penugasan/detail/selesai', 'Penugasan\TugasController@selesai');
    Route::resource('surat','Penugasan\SuratController');
    Route::resource('aktivitas','Penugasan\AktivitasController');
    Route::get('aktifitas/rekap', 'Penugasan\AktivitasController@rekap');
    Route::get('aktifitas/cetak_pdf', 'Penugasan\AktivitasController@cetakPdf');
    Route::get('aktifitas/export_excel', 'Penugasan\AktivitasController@export_excel');
    Route::get("cek/{tgl1}/{tgl2}/{pegawai}", function($tgl1, $tgl2, $pegawai){
        $status = "accepted";
        $cek = \App\Presensi::where('presensi.pegawai_id',$pegawai)
            ->where('presensi.tipe_izin','<>',null)
            ->where('presensi.status_izin',$status)
            ->where('presensi.tipe_izin', 'dinas_luar')
            ->whereBetween('presensi.tgl_presensi',array($tgl1, $tgl2))
            ->count();
        echo $cek;
    });
});

Route::middleware('sudahlogin')->group(function () {
    Route::get("login","Auth\LoginController@showLoginForm")->name('login');
    Route::post("post_login","Auth\LoginController@post_login")->name('post_login');
});

app/Presensi.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Presensi extends Model
{
    protected $table = "presensi";
    protected $fillable = ["pegawai_id","tgl_presensi","waktu_presensi","tipe_presensi",
        "latitude_presensi","longitude_presensi","jarak_presensi","id_rulepresensi",
        "tipe_izin", "tgl_start_izin","tgl_end_izin","bukti_izin","tipe_file","n_telat","keterangan","status_izin",
        "ket_izin_admin"
    ];
    public $timestamps = false;
}

app/TempatPresensi.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class TempatPresensi extends Model
{
    protected $table = "tempat_presensi";
    protected $fillable = ["nama_tempat","alamat","latitude_tempat","longitude_tempat"];
    public $timestamps = false;
}

app/Http/Controllers/Android/PresensiController.php
<?php

namespace App\Http\Controllers\Android;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Carbon\Carbon;
use App\Presensi;
use App\Pegawai;
use App\WaktuPresensi;
use App\RulePresensi;
use App\RuleHariLibur;
use App\DateRecords;
use App\Periode;
use App\Surattugas;

class PresensiController extends Controller
{

    public function __construct(){
        $this->middleware('auth:api');
    }

    public function getTipePegawai($id)
    {
        $tipe = Pegawai::find($id);
        return $tipe->id_tipepeg;
    }


    public function logPresensi(Request $request, $pegawai_id) 
    {
        $tgl_awal = $request->query('tgl_awal');
        $tgl_akhir = $request->query('tgl_akhir');
        if(!empty($tgl_awal) && !empty($tgl_akhir)){
            $data = Presensi::join('rule_presensi','rule_presensi.id','=','presensi.id_rulepresensi')
                ->where('presensi.pegawai_id',$pegawai_id)
                ->whereBetween('presensi.tgl_presensi',array($tgl_awal, $tgl_akhir))
                ->groupBy('presensi.tgl_presensi')
                ->orderBy('presensi.tgl_presensi', 'desc')
                ->select('*','presensi.id as presensi_id')->get();
        }else{
            $data = Presensi::join('rule_presensi','rule_presensi.id','=','presensi.id_rulepresensi')
                ->where('presensi.pegawai_id',$pegawai_id)
                ->groupBy('presensi.tgl_presensi')
                ->orderBy('presensi.tgl_presensi', 'desc')
                ->select('*','presensi.id as presensi_id')->get();
        }
        $presensi = array();
        foreach($data as $row){
            array_push($presensi,[
                "id_presensi" => $row->presensi_id,
                "tgl_presensi" => $row->tgl_presensi,
                "waktu_presensi" => $row->waktu_presensi,
                "tipe_presensi" => $row->tipe_presensi,
                "jam_masuk" => getJamPresensi($row->pegawai_id, $row->tgl_presensi,'jam_masuk'),
                "jam_pulang" => getJamPresensi($row->pegawai_id, $row->tgl_presensi,'jam_pulang'),
                "status_jam_masuk" => getStatusPresensi($row->pegawai_id, $row->tgl_presensi,'jam_masuk'),
                "status_jam_pulang" => getStatusPresensi($row->pegawai_id, $row->tgl_presensi,'jam_pulang')
            ]);
        }
        return response()->json(['data' => $presensi, 'code' => 200]);
    }

    public function getRulePresensi($n_telat, $tipe_presensi)
    {
        $telat = 0;

        if($n_telat == 0){
            $telat = 0;
        }
        else if($n_telat >= 1 && $n_telat <= 30){
            $telat = 30;
        }
        else if($n_telat >= 31 && $n_telat <= 60){
            $telat = 60;
        }
        else if($n_telat >= 61 && $n_telat <= 90 ){
           $telat = 90;
        }else if($n_telat >= 91 ){
            $telat = 91;
        }

        $rule = RulePresensi::where('max_telat_awal',$telat)
            ->where('tipe_presensi',$tipe_presensi)->first();
        return $rule->id;

    }

    public function statistikPresensi(Request $request, $id)
    {
        $awal = $request->query('tgl_awal');
        $akhir = $request->query('tgl_akhir');
        if(!empty($awal) && !empty($akhir)){
            $tgl_awal = $awal;
            $tgl_akhir = $akhir;
        }else{
            $periode = Periode::first();
            $tgl_awal = $periode->periode_awal;
            $tgl_akhir = $periode->periode_akhir;
        }
        $data = array();
        $status = array("TL-1","TL-2","TL-3","TL-4","PSW-1","PSW-2","PSW-3","PSW-4","-","masuk",null,"dl","tm");
        for($i = 0; $i < count($status); $i++){
            $value = 0;
            if($status[$i] == "tm"){
                $value = countTidakHadir(
                    $id,
                    $tgl_awal, $tgl_akhir,
                    countRangeStatusPresensi($id, $tgl_awal, $tgl_akhir,'masuk'),
                    countRangeStatusPresensi($id, $tgl_awal, $tgl_akhir,null),
                );
            }else if($status[$i] == null){
                $value = countRangeStatusPresensi($id, $tgl_awal, $tgl_akhir, $status[$i]) -  countIzinDL($id, $tgl_awal, $tgl_akhir);
            }else if($status[$i] == "dl"){
                $value = countIzinDL($id, $tgl_awal, $tgl_akhir);
            }else{
                $value = countRangeStatusPresensi($id, $tgl_awal, $tgl_akhir, $status[$i]);
            } 
            array_push($data, [
                "status" => $status[$i],
                "jumlah" => $value 
            ]);
        }
        
        return response()->json(["code" => 200, "data" => $data]);
    }

    public function getPeriode()
    {
        $periode = Periode::first();
        return response()->json(["code" => 200, "data" => $periode]);
    }

    public function presensi(Request $request)
    {
        $tgl = Carbon::now()->format('Y-m-d');

        $cekDate = DateRecords::where("tgl_record",$tgl)->count();
        if($cekDate < 1){
            $date = new DateRecords();
            $date->tgl_record = $tgl;
            $date->save();
        }

        $wkt = Carbon::now()->format('H:i:s');
        $waktu_presensi = $request->waktu_presensi;
        $tipe_presensi = $request->tipe_presensi;
        
        if($tipe_presensi == "jam_masuk"){
            $start = strtotime($waktu_presensi);
            $end = strtotime($wkt);
            $mins = ($end - $start) / 60;
        }else{
            $start = strtotime($waktu_presensi);
            $end = strtotime($wkt);
            $mins = ($start - $end) / 60;
        }


        if($mins < 0){
            $n_telat = 0;
        }else{
            $n_telat = $mins;
        }

        $status_presensi = $this->getRulePresensi($n_telat, $tipe_presensi);

        $presensi = Presensi::create($request->except(['tgl_presensi','waktu_presensi','id_rulepresensi','waktu_presensi','tipe_presensi','n_telat'])
            + [
                'tgl_presensi' => $tgl,
                'waktu_presensi' => $wkt,
                'id_rulepresensi' => $status_presensi,
                'tipe_presensi' => $tipe_presensi,
                'n_telat' => $n_telat
            ]);
        return response()->json(['message' => 'success', 'code' => 200 ]);
    }

    public function showTempat($id)
    {
        $data = Pegawai::join('tempat_presensi','tempat_presensi.id','=','pegawai.id_tempat')
            ->where('pegawai.id_pegawai',$id)->first();
        return response()->json(['data' => $data, 'code' => 200]);
    }

    public function showWaktu($id)
    {
        $namaHari = getNameDay();
        $tipePegawai = $this->getTipePegawai($id); 
        // $data = waktu_presensi::where('hari',$namaHari)
        //     ->where('all_pegawai','1')->first();
        // return response()->json(['data' => $data, 'code' => 200]);

        $waktu = WaktuPresensi::where('hari',$namaHari);
        if($waktu->count() > 0){
            foreach($waktu->get() as $row){
                if($row->all_pegawai == 1){
                    $data = WaktuPresensi::where('hari',$namaHari)
                        ->where('all_pegawai',1)->get();
                    return response()->json(['data' => $data, 'code' => 200]);
                }else{
                    $data = WaktuPresensi::where('hari',$namaHari)
                        ->where('id_tipepegawai',$tipePegawai)->get();
                    return response()->json(['data' => $data, 'code' => 200]);
                }
            }
        }else{
            $data = [];
            return response()->json(['data' => $data, 'code' => 200]);
        }
    }

    public function getLibur()
    {
        $libur = RuleHariLibur::where('tanggal',getTanggal())->first();
        if($libur != null){
            $state = true;
        }else{
            $state = false;
        }
        return response()->json(['data' => $libur, 'islibur' => $state, 'code' => 200]);
    }

    public function cekPresensi($pegawai) {
        $count = Presensi::join("rule_presensi","presensi.id_rulepresensi","=","rule_presensi.id")
            ->where("pegawai_id",$pegawai)
            ->where("tgl_presensi",getTanggal())->count();
        if($count == 2){
            $data = "end";
        }
        else if($count == 1){
            $data = "jam_pulang";
        }else {
            $data = "free";
        }
        // else if($count < 1) {
        //     $data = "free";
        // }
        return response()->json(['data' => $data]);
    }

    public function cekSedangTugas($pegawaiId)
    {
        $statusBerangkat = Surattugas::where('pegawai_id',$pegawaiId)
            ->whereDate('tgl_berangkat','<=',getTanggal())
            ->orderBy('tgl_berangkat', 'desc');
        if($statusBerangkat->count() > 0){
            $tglAwal = $statusBerangkat->first()->tgl_berangkat;
            $tglAkhir = $statusBerangkat->first()->tgl_kembali;
        }else{
            $tglAwal = null;
            $tglAkhir = null;
        }

        $status = cekAdaTugas($pegawaiId);
        return response()->json(["status" => $status, 
            "tgl_berangkat" => $tglAwal,
            "tgl_kembali" => $tglAkhir,
            "code" => 200
        ]);
    }

    public function cekSedangIzin($pegawai)
    {
        $cekIzin = Presensi::where('pegawai_id', $pegawai)
            ->whereDate('tgl_start_izin','<=',getTanggal())
            ->orderBy('tgl_start_izin','desc');
        if($cekIzin->count() > 0){
            $tglAwal = $cekIzin->first()->tgl_start_izin;
            $tglAkhir = $cekIzin->first()->tgl_end_izin;
        }else{
            $tglAwal = null;
            $tglAkhir = null;
        }
        $status = cekAdaIzin($pegawai);
        return response()->json(["status" => $status, 
            "tgl_start" => $tglAwal,
            "tgl_end" => $tglAkhir,
            "code" => 200
        ]);
    }
  
}

app/Http/Controllers/Presensi/PeriodeController.php
<?php

namespace App\Http\Controllers\Presensi;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Periode;

class PeriodeController extends Controller
{

    public function index()
    {
        $periode = Periode::first();
        return response()->json(["code" => 200, "periode" => $periode]);
    }
    
    public function store(Request $request)
    {
        $count = Periode::count();
        if($count > 0){
            $periode = Periode::where("id",1)
                ->update([
                    "periode_awal" => $request->periode_awal,
                    "periode_akhir" => $request->periode_akhir
                ]);
        }else{
            $periode = Periode::create($request->all());
        }
        return response()->json(["code" => 200]);
    }

}

resources/views/presensi/tempat_presensi/create_edit.blade.php
@extends('templates.main')
@section('title', $title)
@section('content')			
    <div class="row justify-content-center">
        <div class="col-md-8">
            <nav aria-label="breadcrumb" class="mb-2">
                <ol class="breadcrumb p-0">
                  <li class="breadcrumb-item">
                    <a href="{{ url("/") }}">
                      <span class="mdi mdi-home"></span>                
                    </a>
                  </li>
                  <li class="breadcrumb-item">
                    <a href="{{ route("tempat_presensi.index") }}">Daftar Tempat Presensi             
                    </a>
                  </li>
                  <li class="breadcrumb-item text-success" aria-current="page">
                    @if($page == "edit")Edit @else Tambah @endif Tempat Presensi
                  </li>
                </ol>
            </nav>
            <div class="card card-default">
                <div class="card-header card-header-border-bottom">
                    <h2>@if($page == "edit")Edit @else Tambah @endif Data Tempat Presensi</h2>
                </div>
                <div class="card-body">
                    @if(Session::has('error'))
                        <div class="alert alert-dismissible fade show alert-danger" role="alert">
                            {{ Session::get("error") }}
                            <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                                <span aria-hidden="true">×</span>
                            </button>
                        </div>
                    @endif
                    @if($page == "edit")
                        @php $url = route('tempat_presensi.update', $tempat_presensi->id)  @endphp
                    @else
                        @php $url = url("tempat_presensi")  @endphp
                    @endif
                    <form action="{{ $url }}" method="post">
                        @csrf
                        @if($page == "edit")
                            {{ method_field('put') }}
                        @endif
                        <div class="form-group">
                            <label>Nama Tempat Presensi</label>
                            <input type="text" name="nama_tempat" class="form-control @error('nama_tempat') is-invalid @enderror" 
                                placeholder="Contoh : Kantor Kemenag Jombang" 
                                @if($page == "edit") value="{{ $tempat_presensi->nama_tempat }}" @endif />
                                @error('nama_tempat')
                                    <div class="invalid-feedback">
                                        {{ $message }}  
                                    </div>
                                @enderror    
                        </div>
                        <div class="form-group">
                            <label>Alamat</label>
                            <input type="text" name="alamat" class="form-control @error('alamat') is-invalid @enderror" 
                                placeholder="Contoh : Jl. Pattimura 26 Jombang" 
                                @if($page == "edit") value="{{ $tempat_presensi->alamat }}" @endif />
                                @error('alamat')
                                    <div class="invalid-feedback">
                                        {{ $message }}  
                                    </div>
                                @enderror    
                        </div>
                        <div class="form-group">
                            <label>Lokasi Tempat Presensi</label><br/>
                            <span>Klik salah peta untuk mendapatkan lokasi atau ketik lokasi pada form yang tersedia.</span>
                            <div id="mapLokasiTempat" class="mapLokasiTempat"></div>
                            <div class="row">
                                <div class="col-6">
                                    <input type="text" name="latitude_tempat" class="lat_tempat form-control @error('latitude_tempat') is-invalid @enderror"
                                        placeholder="Contoh : -7.82939" 
                                        @if($page == "edit") value="{{ $tempat_presensi->latitude_tempat }}" @endif />
                                    @error('latitude_tempat')
                                        <div class="invalid-feedback">
                                            {{ $message }}  
                                        </div>
                                    @enderror 
                                </div>
                                <div class="col-6">
                                    <input type="text" name="longitude_tempat" class="long_tempat form-control @error('longitude_tempat') is-invalid @enderror" 
                                        placeholder="Contoh : 110.129293" 
                                        @if($page == "edit") value="{{ $tempat_presensi->longitude_tempat }}" @endif />
                                    @error('longitude_tempat')
                                        <div class="invalid-feedback">
                                            {{ $message }}  
                                        </div>
                                    @enderror 
                                </div>
                            </div>   
                        </div>
                        <div class="form-footer pt-4 pt-5 mt-4 border-top">
                            <button type="submit" class="btn btn-primary btn-default">Simpan</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
    <script>
        var latTempatEdit = JSON.parse(`<?php echo $tempat_presensi->latitude_tempat ?? ''; ?>`);
        var longTempatEdit = JSON.parse(`<?php echo $tempat_presensi->longitude_tempat ?? ''; ?>`);
    </script>
@endsection

resources/views/presensi/tempat_presensi/index.blade.php
@extends('templates.main')
@section('title','Halaman Tempat Presensi')
@section('content')			
    <div class="row justify-content-center">
        <div class="col-md-12">
            <nav aria-label="breadcrumb" class="mb-2">
                <ol class="breadcrumb p-0">
                  <li class="breadcrumb-item">
                    <a href="{{ url("/") }}">
                      <span class="mdi mdi-home"></span>                
                    </a>
                  </li>
                  <li class="breadcrumb-item text-success" aria-current="page">
                    Tempat Presensi 
                  </li>
                </ol>
            </nav>
            <div class="card card-default">
                <div class="card-header card-header-border-bottom">
                    <h2>Data Tempat Presensi</h2>
                </div>
                <div class="card-body">
                    @if(Session::has('success'))
                        <div class="alert alert-dismissible fade show alert-success" role="alert">
                            {{ Session::get("success") }}
                            <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                                <span aria-hidden="true">×</span>
                            </button>
                        </div>
                    @endif
                    <a href="{{ route("tempat_presensi.create") }}" class="btn btn-success btn-pill mb-3"> <i class="fas fa-plus"></i> Tambah Tempat Presensi</a>
                    <table id="data" class="table dt-responsive nowrap" style="width:100%">
                        <thead>
                            <tr>
                                <td>No</td>
                                <td>Tempat Presensi</td>
                                <td>Alamat</td>
                                <td>Lokasi Tempat</td>
                                <td>Aksi</td>
                            </tr>
                        </thead>
                        <tbody>
                            @php $no = 0; @endphp
                            @foreach ($tempat_presensi as $item) @php $no++; @endphp
                                <tr>
                                    <td>{{ $no }}</td>
                                    <td>{{ $item->nama_tempat }}</td>
                                    <td>{{ $item->alamat }}</td>
                                    <td>Latitude : {{ $item->latitude_tempat }} <br/>Longitude : {{ $item->longitude_tempat }}</td>
                                    <td>
                                        <a href="{{ route("tempat_presensi.edit",$item->id) }}" class="btn btn-primary btn-sm">
                                            <i class="fas fa-edit"></i>
                                        </a>
                                        <button type="button" data-toggle="modal" data-target="#exampleModal{{ $item->id }}" 
                                            class="btn btn-danger btn-sm">
                                            <i class="fas fa-trash"></i>
                                        </button>
                                    </td>
                                </tr>

                                <div class="modal fade" id="exampleModal{{ $item->id }}" tabindex="-1" role="dialog">
                                    <div class="modal-dialog" role="document">
                                        <div class="modal-content">
                                            <div class="modal-header">
                                                <h5 class="modal-title" id="exampleModalLabel">Hapus Data</h5>
                                                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                                    <span aria-hidden="true">×</span>
                                                </button>
                                            </div>
                                            <div class="modal-body">
                                                Apakah tempat presensi {{ $item->nama_tempat }} akan dihapus ?
                                            </div>
                                            <div class="modal-footer">
                                                <button type="button" class="btn btn-danger btn-pill" data-dismiss="modal">Tidak</button>
                                                <form action="{{ route('tempat_presensi.destroy', $item->id) }}" method="post"> 
                                                    @csrf
                                                    @method('DELETE')    
                                                    <button type="submit" class="btn btn-primary btn-pill">Ya</button>
                                                </form>
                                            </div>
                                        </div>
                                    </div>
                                </div>

                            @endforeach
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
    </div>
@endsection